package com.idiot.operationbackend.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.idiot.operationbackend.entity.AccountFans;
import com.idiot.operationbackend.mappers.AccountFansMapper;
import com.idiot.operationbackend.service.facade.AccountFansService;
import com.idiot.operationbackend.support.Constants;
import org.springframework.stereotype.Service;

import java.time.LocalDate;
import java.util.List;

/**
 * @author wang xiao
 * @date Created in 19:24 2020/9/10
 */
@Service
public class AccountFansServiceImpl extends ServiceImpl<AccountFansMapper, AccountFans>
        implements AccountFansService {


    @Override
    public AccountFans queryByAccountIdAndOpenId(String accountId, String openId) {
        return getOne(Wrappers.<AccountFans>lambdaQuery().eq(AccountFans::getAccountId,accountId)
                .eq(AccountFans::getOpenId,openId),false);
    }


    @Override
    public int countFansByAccountId(String accountId) {
        return count(Wrappers.<AccountFans>lambdaQuery().eq(AccountFans::getAccountId,accountId));
    }


    @Override
    public List<AccountFans> queryFansByDateAndDate(String accountId, String startDate, String endDate) {
        LocalDate end = LocalDate.parse(endDate).plusDays(1);
        String endStr = end.format(Constants.DATE_FORMATTER);
        return list(Wrappers.<AccountFans>lambdaQuery()
                .eq(AccountFans::getAccountId,accountId)
                .ge(AccountFans::getUpdateTime,startDate)
                .le(AccountFans::getUpdateTime,endStr));
    }
}
